routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;


Auth::routes();

//Landing Page
Route::get('/', function () {
    return view('welcome');
});

//minimum user / logged in user
Route::group(['middleware' => ['level:1']], function () {
    //minimum Teacher
    Route::group(['middleware' => ['level:4']], function () {
        Route::group(['middleware' => ['level:5']], function () {
        });
        Route::resource('courses', 'CoursesController');
        Route::resource('courses.assignments', 'AssignmentController');
        Route::resource('courses.assignments.handin','HandinController');
        Route::resource('courses.assignments.handin.grade','GradeController');
        Route::get('courses/{course}/assignments/{assignment}/handin/{handin}/download','HandinController@downloadhandin')->name('course.assignments.handin.download');
        Route::resource('video','VideoController');
        Route::resource('users', 'UserController');

    });

    Route::resource('dashboard', 'DashboardController');

    Route::resource('forum', 'ForumController', ['except' => ['show']])->parameters(['forum' => 'category']);
    Route::resource('forum.topic', 'ForumTopicController')->parameters(['forum' => 'category']);
    Route::resource('forum.topic.post', 'ForumTopicPostController')->parameters(['forum' => 'category']);

    Route::resource('courses', 'CoursesController', ['only' => ['index']]);

    Route::resource('courses.assignments', 'AssignmentController', ['only' => ['index','show']]);
    Route::resource('courses.assignments.handin','HandinController', ['only' => ['create','store']]);

    Route::get('courses/{course}/assignments/{assignment}/handin/{handin}/download','HandinController@downloadhandin')->name('course.assignments.handin.download');

    Route::resource('profile', 'ProfileController');
    Route::resource('dashboard', 'DashboardController');
    Route::resource('contact','ContactController');
    Route::post('search', 'DashboardController@search')->name('search');

    Route::resource('videos', 'VideoController');

    //botman routes
    Route::match(['get', 'post'], '/botman', 'BotManController@handle');
});

app/Http/Controllers/ForumController.php
<?php

namespace App\Http\Controllers;

use App\ForumCategory;
use App\ForumPost;
use App\ForumTopic;
use App\Http\Requests\CreateForumCategoryRequest;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class ForumController extends Controller
{
    public function index()
    {
        $category = ForumCategory::all();
        $user = Auth::user();
        return view('forum.index', ['category' => $category, 'user' => $user]);
    }

    public function create()
    {
        return view('forum.category.create');
    }

    public function store(CreateForumCategoryRequest $request)
    {
        if (!$request->validated()) {
            return redirect()->back()->withInput($request->input())->withErrors($request);
        }
        $category = new ForumCategory();
        $category->name = $request['name'];
        $category->description = $request['description'];
        $category->save();
        return redirect()->route('forum.index');

    }

    public function update(CreateForumCategoryRequest $request, ForumCategory $category)
    {
        $category->name = $request['name'];
        $category->description = $request['description'];
        $category->save();
        return redirect()->route('forum.index');
    }

    public function destroy(ForumCategory $category)
    {
        $category->delete();
        return redirect()->route('forum.index');
    }
}

resources/views/forum/post/edit.blade.php
@extends('layouts.dashboard')
@section('content')
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{route('dashboard.index')}}">Dashboard</a></li>
            <li class="breadcrumb-item"><a href="{{route('forum.index')}}">Categories</a></li>
            <li class="breadcrumb-item"><a href="{{route('forum.topic.index',$category->id)}}">Topics</a></li>
            <li class="breadcrumb-item"><a href="{{route('forum.topic.post.index',[$category->id,$topic->id,$post->id])}}">{{$category->name}}&nbsp; Posts</a></li>
            <li class="breadcrumb-item active" aria-current="page">Edit post</li>
        </ol>
    </nav>
    <div class="container-sm" style="margin-top:50px;">
        <h1>Edit Post</h1>
        <form action="{{route('forum.topic.post.update',[$category->id,$topic->id,$post->id])}}" method="post">
            @method('PUT')
            @csrf
            <label for="subject">Subject</label>
            <input id="subject" type="text" name="subject" class="form-control" value="{{$post->subject}}" required>
            <br>
            <label for="message">Message</label>
            <textarea id="message" type="text" name="message" class="form-control" rows="6" required>{{$post->message}}</textarea>
            @foreach($errors->all() as $error)
                <p class="text-danger">
                    {{ $error }}
                </p>
            @endforeach
            <button type="submit" class="btn btn-primary" style="margin-top:10px;">Edit post</button>
        </form>
    </div>

@endsection()

resources/views/forum/post/index.blade.php
@extends('layouts.dashboard')
@section('content')
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{route('dashboard.index')}}">Dashboard</a></li>
            <li class="breadcrumb-item"><a href="{{route('forum.index')}}">Categories</a></li>
            <li class="breadcrumb-item"><a href="{{route('forum.topic.index',[$category->id])}}">Topics</a>
            </li>
            <li class="breadcrumb-item active" aria-current="page">{{$category->name}}&nbsp; Forum</li>
        </ol>
    </nav>
    <div class="container-sm" style="margin-top:50px;">
        <h1>Create Post</h1>
        <form href="{{route('forum.topic.post.store',['category'=>$category->id,'topic'=>$topic->id])}}" method="post">
            @csrf
            <label for="subject">Subject</label>
            <input id="subject" type="text" name="subject" class="form-control" required>
            <br>
            <label for="message">Message</label>
            <textarea id="message" type="text" name="message" class="form-control" required></textarea>

            @foreach($errors->all() as $error)
                <p class="text-danger">
                    {{ $error }}
                </p>
            @endforeach
            <button type="submit" class="btn btn-primary" style="margin-top:10px;">Create post</button>
        </form>
    </div>
    <div class="container-sm">
        @foreach($posts as $post)
            <div class="card" style="width: 80%;margin :20px auto; display: block;">
                <div class="card-body">
                    <div class="row">
                        <div class="col-sm-6 float left"><h4 class="card-title">{{$post->user->name}}</h4><br></div>
                        <div class="col-sm-6 float-right"><h6 class="card-title  text-muted float-right">{{$post->updated_at->format('d-m-Y H:i:s')}}</h6></div>
                    </div>
                    <h5 class="card-text">Subject: {{$post->subject}}</h5>
                    <h6 class="card-text">Message: {{$post->message}}</h6>
                    @if($post['user_id'] == Auth::id())
                        {{ Form::open(['method' => 'DELETE', 'route' => ['forum.topic.post.destroy','category'=>$category->id,'topic'=>$topic->id,'post'=>$post->id]]) }}
                        <button type="submit" class="card-link" style="color:#3490dc; padding: 0; border:none; margin:0; background-color: white;">Remove Post</button>
                        <a href="{{route('forum.topic.post.edit',[$category->id,$topic->id,$post->id])}}" class="card-link float-right">Edit post</a>
                        {{ Form::close() }}
                    @endif
                </div>
            </div>
        @endforeach()
    </div>
@endsection()